.686 
.model flat,stdcall 
option casemap:none 

include windows.inc
include kernel32.inc
include user32.inc
include gdi32.inc
include Comctl32.inc
include comdlg32.inc
include masm32.inc

includelib kernel32.lib
includelib user32.lib
includelib gdi32.lib
includelib Comctl32.lib
includelib comdlg32.lib
includelib masm32.lib


ico 	        equ 2001


.data? 
hwnd            dd ?
hInstance	HINSTANCE   ?
DllBase         dd ?
wc              WNDCLASSEX  <>
ORIGESP         dd ?                      
ORIGEBP         dd ?                     
EXPESP          dd ? 
PROCADR         dd ?
REGEAX          dd ?
REGECX          dd ?
REGEDX          dd ?
REGEBX          dd ?
REGESI          dd ?
REGEDI          dd ?
NARG            dd ?
ARGLIST         dd 10 dup(?) 
ESPDIFF         dd ?
msg             MSG <>
PSTRUCT         dd ?             
CTEXT macro Text:VARARG
	local szText
	.data
	 szText byte Text, 0
	.code
	exitm <offset szText>
endm


.code 
WndProc proc  hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
        .if uMsg==WM_CREATE                
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg==WM_PAINT
	        invoke BeginPaint,hWnd,offset PSTRUCT
	        invoke EndPaint,hWnd,offset PSTRUCT
	.elseif uMsg==WM_CLOSE
		invoke DestroyWindow,hWnd
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam   
		ret    
	.endif
	ret
WndProc endp

start: 

        mov ebp,esp
        invoke GetModuleHandle,0
        mov hInstance,eax
        invoke GetCommandLine
        mov esi,eax
        inc esi
        cmp al, 22h
        je @next
@@:
        .if al==0
                invoke MessageBox,0,CTEXT("Missing DLL name"),0,MB_OK
                invoke ExitProcess,0
        .endif
        mov al, byte ptr [esi+1]
        inc esi
        cmp al, 22h
        jnz @b
@next:
        mov al, byte ptr [esi+1]
        inc esi
        cmp al, 20h
        jnz @load
@@:
        mov al, byte ptr [esi+1]
        inc esi
        cmp al, 20h
        je @b
@load:
        invoke LoadLibraryEx,esi,NULL,DONT_RESOLVE_DLL_REFERENCES         
        .if eax==0
                invoke MessageBox,0,CTEXT("Unable to load DLL"),0,MB_OK
                invoke ExitProcess,0
        .endif
        mov DllBase,eax
        mov   wc.cbSize,SIZEOF WNDCLASSEX 
        mov   wc.style, CS_HREDRAW or CS_VREDRAW 
        mov   wc.lpfnWndProc, OFFSET WndProc 
        mov   wc.cbClsExtra,NULL 
        mov   wc.cbWndExtra,NULL 
        push  hInstance
        pop   wc.hInstance 
        mov   wc.hbrBackground,COLOR_APPWORKSPACE 
        mov   wc.lpszMenuName,NULL 
        mov   wc.lpszClassName,CTEXT("LoadDLLClass")
        invoke LoadIcon,NULL,ico
        mov   wc.hIcon,eax 
        mov   wc.hIconSm,eax 
        invoke LoadCursor,NULL,IDC_ARROW 
        mov   wc.hCursor,eax 
        invoke GetStockObject,WHITE_BRUSH
        mov   wc.hbrBackground,eax
        invoke RegisterClassEx, addr wc 
        invoke CreateWindowEx,NULL,CTEXT("LoadDLLClass"),CTEXT("DLL Loader"),WS_OVERLAPPEDWINDOW+WS_VISIBLE,CW_USEDEFAULT, CW_USEDEFAULT,200,100,NULL,NULL,hInstance,NULL 
        mov hwnd,eax
        invoke ShowWindow,eax,SW_RESTORE
Firstbp:   
       nop                         ; First breakpoint is set here
WINLOOP:    
        .if PROCADR==0
                jmp NoCall
        .endif
        mov ORIGESP,esp
        mov ORIGEBP,ebp
        push 0              
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        push 0
        mov ecx,NARG
        jecxz @@44
        .if ecx>0Ah
        	 invoke MessageBox,0,CTEXT("̫"),0,MB_OK
                 invoke ExitProcess,0
        .endif
        mov eax,offset ARGLIST
@@42:   
        push [eax]   
        add eax,4
        loop  @@42  
@@44:   
        mov [EXPESP],esp
        mov eax,[REGEAX]
        mov ecx,[REGECX]
        mov edx,[REGEDX]
        mov ebx,[REGEBX]
        mov esi,[REGESI]
        mov edi,[REGEDI]
Prepatch:    
        nop                  
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
CallDLL: 
        call [PROCADR] 
        nop                    
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        mov [REGEAX],eax
        mov [REGECX],ecx
        mov [REGEDX],edx
        mov [REGEBX],ebx
        mov [REGESI],esi
        mov [REGEDI],edi
        mov eax,esp
        sub eax,[EXPESP]
        mov [ESPDIFF],eax
        mov ebp,[ORIGEBP]
        mov esp,[ORIGESP]
        mov [PROCADR],0
        nop
Finished: 
        int 3                  
        nop
        
NoCall:   
        invoke Sleep,0 
        invoke PeekMessage,offset msg,0,0,0,PM_REMOVE
        .if eax==0
        	jmp WINLOOP
        .endif
        invoke TranslateMessage,offset msg
        invoke DispatchMessage,offset msg
        lea eax,offset msg
        mov eax,[eax+4]
        .if eax!=12h
        	jmp WINLOOP
        .endif
        invoke ExitProcess,0
        xchg ebx, ebx
Patcharea: 
        db 2047 dup(90h)           
Endpatch:  
         nop

end start 
